Option Strict Off
Option Explicit On 

Imports Microsoft.VisualBasic
Imports System
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Windows.Forms

Namespace DataGridTextBoxCombo
    Public Class Form1
        Inherits Form
        Private WithEvents dataGrid1 As DataGrid
        Private WithEvents myDataSet As DataSet
        Friend WithEvents Button1 As System.Windows.Forms.Button
        Private components As Container
        'Fields
        'Constructors
        'Events
        'Methods
        Public Sub New()
            MyBase.New()
            '
            ' Required for Windows Form Designer support
            '
            InitializeComponent()
            SetUp()

        End Sub
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)

            If disposing Then
                If (Not (components) Is Nothing) Then
                    components.Dispose()
                End If
            End If
            MyBase.Dispose(disposing)

        End Sub
        Private Sub SetUp()

            MakeDataSet()
            dataGrid1.SetDataBinding(myDataSet, "Customers")
            AddCustomDataTableStyle()

        End Sub
        Private Sub MakeDataSet()

            ' Create a DataSet.
            myDataSet = New DataSet("myDataSet")
            Dim tCust As DataTable
            tCust = New DataTable("Customers")
            ' Create two columns, and add them to the first table.
            Dim cCustID As DataColumn
            cCustID = New DataColumn("custID")
            Dim cCustName As DataColumn
            cCustName = New DataColumn("custName")
            Dim cCurrent As DataColumn
            cCurrent = New DataColumn("custCity")
            tCust.Columns.Add(cCustID)
            tCust.Columns.Add(cCustName)
            tCust.Columns.Add(cCurrent)
            tCust.Columns.Add(New DataColumn("Col1"))
            tCust.Columns.Add(New DataColumn("Col2"))
            ' Add the tables to the DataSet.
            myDataSet.Tables.Add(tCust)
            ' Populates the table. 
            Dim newRow1 As DataRow
            ' Create three customers in the Customers Table.
            Dim i As Integer
            i = 1

            Do While (i < 4)
                newRow1 = tCust.NewRow
                newRow1("custID") = i.ToString()
                tCust.Rows.Add(newRow1)
                i = (i + 1)

            Loop
            ' Give each customer a distinct name.
            tCust.Rows(0)("custName") = "John Summers"
            tCust.Rows(1)("custName") = "Phil Seagram"
            tCust.Rows(2)("custName") = "Sam Robinson"
            ' And address
            tCust.Rows(0)("custCity") = "Chicago"
            tCust.Rows(1)("custCity") = "Los Angeles"
            tCust.Rows(2)("custCity") = "Washington"

        End Sub
        Private Sub AddCustomDataTableStyle()

            Dim ts1 As DataGridTableStyle
            ts1 = New DataGridTableStyle()
            ts1.MappingName = "Customers"
            ' Set other properties.
            ts1.AlternatingBackColor = Color.LightGray
            '
            ' Add 2 cols with textbox column style
            Dim TextCol As DataGridTextBoxColumn
            TextCol = New DataGridTextBoxColumn()
            TextCol.MappingName = "custID"
            TextCol.HeaderText = "CustomerID"
            TextCol.Width = 80
            ts1.GridColumnStyles.Add(TextCol)
            TextCol = New DataGridTextBoxColumn()
            TextCol.MappingName = "custName"
            TextCol.HeaderText = "Customer Name"
            TextCol.Width = 100 '100
            ts1.GridColumnStyles.Add(TextCol)


            ' Step 2 - Use the combo column style 
            ' Add 1 col with combo style
            Dim ComboTextCol As DataGridComboBoxColumn
            ComboTextCol = New DataGridComboBoxColumn()
            ComboTextCol.MappingName = "custCity"
            ComboTextCol.HeaderText = "Customer Address"
            ComboTextCol.Width = 100
            ts1.GridColumnStyles.Add(ComboTextCol)
            ' Step 3 - Additional setup for Combo style
            ' a) make the row height a little larger to handle minimum combo height
            ts1.PreferredRowHeight = (ComboTextCol.ColumnComboBox.Height + 3)
            ' b) Populate the combobox somehow. It is a normal combobox, so whatever...
            ComboTextCol.ColumnComboBox.Items.Clear()
            ComboTextCol.ColumnComboBox.Items.Add("Chicago")
            ComboTextCol.ColumnComboBox.Items.Add("Corvallis")
            ComboTextCol.ColumnComboBox.Items.Add("Denver")
            ComboTextCol.ColumnComboBox.Items.Add("Great Falls")
            ComboTextCol.ColumnComboBox.Items.Add("Kansas City")
            ComboTextCol.ColumnComboBox.Items.Add("Los Angeles")
            ComboTextCol.ColumnComboBox.Items.Add("Raleigh")
            ComboTextCol.ColumnComboBox.Items.Add("Washington")
            ' c) set the dropdown style of the combo...
            ComboTextCol.ColumnComboBox.DropDownStyle = ComboBoxStyle.DropDownList

            TextCol = New DataGridTextBoxColumn()
            TextCol.MappingName = "Col1"
            TextCol.HeaderText = "col1"
            TextCol.Width = 80 '100
            ts1.GridColumnStyles.Add(TextCol)
            TextCol = New DataGridTextBoxColumn()
            TextCol.MappingName = "Col2"
            TextCol.HeaderText = "col2"
            TextCol.Width = 80 '100
            ts1.GridColumnStyles.Add(TextCol)

            'add the custom table style to the datagrid table styles
            dataGrid1.TableStyles.Add(ts1)

        End Sub
        Private Sub InitializeComponent()
            Me.dataGrid1 = New System.Windows.Forms.DataGrid
            Me.Button1 = New System.Windows.Forms.Button
            CType(Me.dataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
            Me.SuspendLayout()
            '
            'dataGrid1
            '
            Me.dataGrid1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                        Or System.Windows.Forms.AnchorStyles.Left) _
                        Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
            Me.dataGrid1.DataMember = ""
            Me.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText
            Me.dataGrid1.Location = New System.Drawing.Point(56, 50)
            Me.dataGrid1.Name = "dataGrid1"
            Me.dataGrid1.Size = New System.Drawing.Size(556, 190)
            Me.dataGrid1.TabIndex = 0
            '
            'Button1
            '
            Me.Button1.Location = New System.Drawing.Point(245, 13)
            Me.Button1.Name = "Button1"
            Me.Button1.Size = New System.Drawing.Size(148, 23)
            Me.Button1.TabIndex = 1
            Me.Button1.Text = "Hide Columns"
            Me.Button1.UseVisualStyleBackColor = True
            '
            'Form1
            '
            Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            Me.ClientSize = New System.Drawing.Size(692, 277)
            Me.Controls.Add(Me.Button1)
            Me.Controls.Add(Me.dataGrid1)
            Me.Name = "Form1"
            Me.Text = "Form1"
            CType(Me.dataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
            Me.ResumeLayout(False)

        End Sub
        <STAThread()> _
        Public Shared Sub Main()

            Application.Run(New Form1())

        End Sub


        Private Sub dataGrid1_CurrentCellChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles dataGrid1.CurrentCellChanged
            If dataGrid1.TableStyles(0).GridColumnStyles(dataGrid1.CurrentCell.ColumnNumber).Width = 0 Then
                If (Control.ModifierKeys And Keys.Shift) <> 0 Then
                    dataGrid1.CurrentCell = New DataGridCell(dataGrid1.CurrentCell.RowNumber, dataGrid1.CurrentCell.ColumnNumber - 1)
                Else
                    dataGrid1.CurrentCell = New DataGridCell(dataGrid1.CurrentCell.RowNumber, dataGrid1.CurrentCell.ColumnNumber + 1)
                End If
            End If
        End Sub

        Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
            dataGrid1.TableStyles(0).GridColumnStyles(1).Width = 0
            dataGrid1.TableStyles(0).GridColumnStyles(3).Width = 0
        End Sub
    End Class
End Namespace
